# -*- coding:utf-8 -*-

# 添加库
import os
import random
import re
import socket
import time
import pymysql
import requests
import func_timeout
from retrying import retry
from func_timeout import func_set_timeout

# 全局变量
# =====================================================================================================
dealResult = []
dflag = 0 #下载文件地址，0，1交叉下载
# 系统,网络函数
# =====================================================================================================
# 函数 gethostname() 返回当前正在执行 Python 的系统主机名
localIp = socket.gethostbyname(socket.gethostname())

# 清屏，减少内存占用
def clearMemery():
    cmd_str = "cls"
    os.system(cmd_str)


# 重试函数
def retry_if_error(exception):
    print("---------------------------")
    return isinstance(exception, func_timeout.exceptions.FunctionTimedOut)


# 数据库相关
# =====================================================================================================

# 打开数据库连接
db = pymysql.connect(host="172.16.100.200", user="root", password="Dial9527!", database="dialdb", port=3306,
                     charset="UTF8MB4")

# # 创建游标
cursor = db.cursor()


# 数据库批量修改函数
# update_date存储的数据  目前只有账户状态
def update_many(update_data_parm):
    # 修改数据库数据
    updateSql = "update dial_acount_zgno set u_status=(%s),flag=(%s),downflag=(%s),localip=(%s) where id=(%s) "
    try:
        # 执行str保存的语句
        cursor.executemany(updateSql, update_data_parm)  # updateSql 是语句 ; update_date中存的 状态 账户
        # 上传执行结果 查询没有改变数据库 不用上传
        db.commit()
    except:
        # 执行失败就进行数据库回滚
        db.rollback()


# 下载相关函数
# =====================================================================================================
# 下载函数
def download_file(url):
    cmd_str = "fget.exe -m 314572800 -u %s -t 3 " % url  # "rasdial %s /disconnect" % self.name
    os.system(cmd_str)
    dealResult.append(1)  # 下载成功  


# 下载外网100m
def down_test():
    print('开始下载...')
    try:
        T1 = time.time()
        num = random.randint(3, 4)

        for j in range(num):
            # req = requests.get('http://61.139.26.94:8081/500.data', stream=True)
            req = requests.get('http://61.139.26.94:8081/100.data', stream=True)
            for content in req.iter_content(chunk_size=1048576):
                print('.', end='')
        T2 = time.time()
        T_amo = (T2 - T1) * 1000
        spd = num * 100 / (T2 - T1)
        print('{0}\t下载时间: {1} ms,\t下载速度： {2}M/s'.format("文件下载", T_amo, spd))
        dealResult.append(1)  # 下载成功
    except:
        print('文件下载失败')
        dealResult.append(0)  # 下载失败


# =========================================================================================================
# 拨号函数

def getPassWD(acount):
    if acount.upper().find('PZH') != -1:
        if acount.upper().index('PZH') == 0:
            return re.sub('[A-z]', '', acount, 3)
        else:
            return re.sub('[A-z]', '', acount, 2)
    else:
        return re.sub('[A-z]', '', acount, 2)


class Adsl(object):
    # __init__ : name: adsl名称
    
    def __init__(self):
        self.name = 'asd'
        self.username = '123@default0'
        self.password = '12345678'
        self.cursor = cursor

    # set_adsl : 修改adsl设置
    def set_adsl(self, account,pd):
        # self.name = account["name"]
        self.username = account
        self.password = pd

    def conn1(self):
        # 第一种密码策略 只留数字
        passwd1 = re.sub(r'[A-z@]', '', self.username)  # re.sub('[A-z]', '', self.username, 2)
        cmd_str = "rasdial %s %s %s" % (self.name, self.username, passwd1)
        flag = os.system(cmd_str)

        # 若第一种密码策略失败
        if flag != 0:
            time.sleep(3)
            # 使用第二种密码策略 去掉头本地网字母
            # 如果1,2种策略的密码相同，就不拨号了，直接执行下一种密码策略
            passwd = getPassWD(self.username)
            if passwd1 != passwd:
                cmd_str = "rasdial %s %s %s" % (self.name, self.username, passwd)
                flag = os.system(cmd_str)

            # 若第二种策略失败
            if flag != 0:
                time.sleep(3)
                # 使用第三种密码策略 12345678
                passwd = '12345678'
                cmd_str = "rasdial %s %s %s" % (self.name, self.username, passwd)
                flag = os.system(cmd_str)
        return flag

    # connect : 宽带拨号
    @retry(retry_on_exception=retry_if_error)
    @func_set_timeout(60)  # 设定函数超执行时间_
    def connect(self):
        try:
            flag = self.conn1()
            return flag
        except func_timeout.exceptions.FunctionTimedOut:
            print('！！连接超时')
            raise func_timeout.exceptions.FunctionTimedOut

    # disconnect : 断开宽带连接
    def disconnect(self):
        cmd_str = "rasdial %s /disconnect" % self.name
        os.system(cmd_str)
        time.sleep(1)

    # reconnect : 重新进行拨号
    # 设置超时时间
    @retry(retry_on_exception=retry_if_error)
    @func_set_timeout(300) #设定函数超时执行时间
    def reconnect(self):
        self.disconnect()

        flag = self.connect()
    
        # 运行成功开始下载
        if flag == 0:
            # 下载文件
            dealResult.append(2)  # 登陆成功
            dealResult.append(flag)  # 登陆成功
            # down_test()
            global dflag
            if dflag==1:
                download_file('http://61.139.26.94:8081/500.data')
                dflag=0
            else:
                download_file('http://61.139.26.94:8081/500.data')
                dflag=1
        else:
            dealResult.append(3)  # 登陆失败
            dealResult.append(flag)  # 登陆成功
            dealResult.append(0)  # 下载失败


# ===================================================================================================
# 主函数
if __name__ == "__main__":
    # download_file('http://61.139.26.94/file/test500.zip')
    # count = 0
    while True:
        # 执行sql语句,查询未解绑数据进行处理
        cursor.execute(
            "select t.id,t.dial_account,t.latn_name,release_flag from dial_acount_zgno t where u_status=0 limit 3")  # 是否执行过解绑操作
        myresult = cursor.fetchall()
        if len(myresult) > 0:
            a = Adsl()
            j = 1
            update_data = []
            for i in myresult:
                dealResult.append(1)  # [1]
                dealResult.append(0)  # 错误码 默认为0，成功
                dealResult.append(0)  # [1, 0]
                dealResult.append(localIp)  # [1, 0, localip]
                dealResult.append(i[0])  # 1,：正在处理，id        [1, 0, localip, latn_name]
                update_data.append(dealResult)  # [[1, 0, localip, latn_name], [1, 0, localip, latn_name]]
                dealResult = []
            update_many(update_data)  # 更新正在处理状态

            update_data = []
            for i in myresult:
                print(i[1])
                a.set_adsl(i[1],"")  # 设置账号
                try:
                    a.reconnect()
                    dealResult.append(localIp)
                    dealResult.append(i[0])
                    update_data.append(dealResult)
                    dealResult = []
                except Exception as result:
                    print("1未知错误 %s" % result)
                j += 1
                time.sleep(1)
            update_many(update_data)  # 更新正在处
            continue
        else:
            # 如果没有可处理的数据，等待5分钟
            time.sleep(300)


# 网络结构：服务器双网卡，一个管理，一个业务

# mysql表结构
# create database dialdb CHARACTER SET utf8mb4;
# create table dial_acount_zgno (
# id int auto_increment primary key,
# dial_account varchar(32),
# latn_name varchar(32),
# release_flag varchar(32),
# u_status varchar(32),
# flag varchar(32),
# downflag varchar(32),
# localip varchar(32),
# create_time DATETIME);

# mysql设置允许外部访问
# u_status
# 0未处理，1正在拨号，2拨号成功，3拨号失败
# downflag
# 下载标识；0失败，1成功

# python脚本，exe都放在同一路径下
# 1、安装mini anaconda（python）
# 2、安装pip设置国内源
# 3、pip安装必要的包，可跑起来，看报错，根据报错安装

# 使用临时网段61.157.63.96/27